// widz_apmon.c
//
// by FATBLOKE
//
// This sad little program monitors an area for Access Points
// If finds an ap it compares it to a list stored in a config file
//
// if the AP isnt in list it calls a program called Alert with an
// appropriate message.  The example alert script sent a syslog
// message which in our example will be picked up by snort
// - but it could sent an snmp trap or a command.
//
// This is only a proof on concept - the development of which has been
// bogged down by a series of trials some technical, some managerial
// and emotional  - please see doc for suggested  improvements
//
//
//
#include "iwcommon.h"
char old_essid[50], old_ap[50];
char wdev[6];
int sleeptime, count;
int monitor;
int generate;
char *pattern[100];
FILE *ff;
int  DEBUG = 0;

#define  MAXAP 99
#define   CONF_FILE  "widz-ap.config"


/**************************************************
                        
 **************************************************/

int 
reset_essid(int sock, const char *ifname)
{
  char essid_buf[IW_ESSID_MAX_SIZE + 1];
  struct iwreq wrq;

  memset(&wrq, 0, sizeof(wrq));
  memset(essid_buf, 0, sizeof(essid_buf));
    wrq.u.essid.flags = 0;
  strcpy(wrq.ifr_name, ifname);

  strcpy(essid_buf, "");
  wrq.u.essid.flags = 0;
  wrq.u.essid.pointer = (caddr_t) essid_buf;
  wrq.u.essid.length = strlen(essid_buf) + 1;

  if(ioctl(sock, SIOCSIWESSID, &wrq) < 0) {
    return 0;
  }

  return 1;
}

/**************************************************
                        
 **************************************************/


 // clean subroutine a botch to remove shell escapes designed to remove
char * cleanit (  char * clean)
{
char * temp_ptr;

	while ( (temp_ptr = strpbrk( clean, ";'&!`)") ) )
	{
	*temp_ptr = '.';
	}

	return clean;
	}
	


/**************************************************
                        
 **************************************************/


do_alert(char *target)
  {
  char mess[100];
  if ( DEBUG )
    printf("Alert unknown AP %s\n", target);
  sprintf(mess,"Alert 'unknown AP %s\n'", cleanit(target));
  setenv ("WIDZMSG", mess,1);
  system("Alert");
  }



/**************************************************
                        
 **************************************************/

 
void
monitor_mode()
  {
  char target[100];
  int i;
  sprintf(target,"essid=%s ap_mac=%s\n",old_essid ,  old_ap);
  for (i=0;  count > i ; i++)
    {
    if ( DEBUG )
      {
      printf("Debug monitor_mode() - Does  %s match this pattern >",(char *) target    );
	printf("%s < stored in database index # %i\n", pattern[i], i);
       }
    //
     if ( strcmp(target, (char *) pattern[i]) == 0 )
	{
        if ( DEBUG )
          printf("Debug - yes match \n" );
 	return ;
	}
     if ( DEBUG )
	printf("Debug - No  match \n" );
      }
  // end for
    if ( DEBUG )
       printf("Alert unknown AP essid=%s ap_mac=%s\n",old_essid ,  old_ap);
    //
    //
        do_alert(target);
         
       }

/**************************************************
 Load memory            
 **************************************************/
void 
loadpattern()
  {
  char target[100];
  int i;
  if ( (ff=fopen(CONF_FILE,"r")) == NULL )
	perror("file");

	
   for (i=0; i < MAXAP; i++)
     {
     if ( fgets(target, 80 , ff) == NULL )
	{
        count = i;	
	return ;
	}
      pattern[i] = strdup(target) ;
			 
      if ( DEBUG )
         printf("Debug: Loadpattern() loading index# %i with  pattern=%s \n",i, (char *)pattern[i]) ;
     }
         
  }
/**************************************************
                        
 **************************************************/



/*
 *	for dumping the frame in hex
 */
char *macit(__u8 * x)
{
	char mac[18];
    sprintf (mac,"%02x:%02x:%02x:%02x:%02x:%02x", 
		    x[0], x[1], x[2], x[3], x[4], x[5]);
    return(strdup(mac));
}
/**************************************************
Get ESSID name from  interface 
 **************************************************/

char *
get_essid(int sock, const char *ifname)
{
  struct iwreq		wrq;
  struct wireless_info  info_local, *info = &info_local;

  char   essid_buf[IW_ESSID_MAX_SIZE + 1];

  memset(essid_buf, 0, sizeof(essid_buf));
  memset(info, 0, sizeof(struct wireless_info));
  memset(&wrq, 0, sizeof(wrq));

  /* Get ESSID */
  strcpy(wrq.ifr_name, ifname);
  wrq.u.essid.pointer = (caddr_t) essid_buf;
  wrq.u.essid.length = 0;
  wrq.u.essid.flags = 0;
  if(ioctl(sock, SIOCGIWESSID, &wrq) >= 0) {
    info->has_essid = 1;
    info->essid_on = wrq.u.data.flags;
  } else {
    fprintf(stderr, "SIOCGIWESSID: %s\n", strerror(errno));    
  }
  if(info->has_essid == 0 || essid_buf[0] == '\0' || strncmp(essid_buf, "non-specified SSID !!",8) == 0)
    return NULL;
  return strdup(essid_buf);
}
/**************************************************
Get AP MAC  from  interface 
 **************************************************/

char *get_ap(int sock, const char *ifname)
{
  struct iwreq		wrq;
  struct wireless_info  info_local, *info = &info_local;

  memset(info, 0, sizeof(struct wireless_info));
  memset(&wrq, 0, sizeof(wrq));

  strcpy(wrq.ifr_name, ifname);

  if(ioctl(sock, SIOCGIWAP, &wrq) >= 0) {
    info->has_ap_addr = 1;
    memcpy(&(info->ap_addr), &(wrq.u.ap_addr), sizeof (sockaddr));
  }

  if(strcmp(info->ap_addr.sa_data, "DDDDDD") == 0) {

    return NULL;
  }
   
  return( macit(info->ap_addr.sa_data));
  // return strdup( hexdump(info->ap_addr.sa_data,6) );
}

  


/**************************************************
 some global definitions 
 **************************************************/


/***************************************************************************
 
 ***************************************************************************/
/* 
   Assume Interface is up & Associated
   Read the ESSID from the interface
   then get the MAC of the AP
   lookup the MAC and ESSID to see if we've seen b4 if yes exit 
   store  the MAC  ESSID 
   reset ESSID to force the card to search for another AP

   wait a couple seconds 
 
 ***************************************************************************/

void look()
{

  int sock = socket(AF_INET, SOCK_DGRAM, 0);
  int i  = 0 ;
  char *essid, *ap;
  char temp[50];
  char ap_store[1000];
  memset( old_essid, ' ',50);
  memset( old_ap, ' ',50);
  memset( ap_store, 0,1000);
  while( i < 100 )  // arbitary 100 APs
  {      
  memset( temp, 0,50);


  //   get essid  
   
	  i++;

  essid =get_essid(sock, wdev   ) ;
     
   if ( essid == NULL  )
	     break;
  //   get mac    
     ap=get_ap(sock, wdev);
     if ( ap == NULL )
     {
        if ( DEBUG )
             printf("Debug look() essid=%s ap_mac is null \n",essid );
	     break;
     }

     if ( DEBUG )
          printf("Debug look() essid=%s ap_mac=%s index %i\n",essid ,  ap, i);
      
     // store mac essid check to see if we've seen it before
     strcpy(temp,essid) ;
     strcat(temp,  ap);
     // null mac address                                          
     if ( strstr(ap_store,temp) != NULL )
     {
	     break;
     }
     // should check for ESSID = non-spec* as returned by Wavelan
     // or BSSID 44:44:44:*     as Host_ap and others
     // but havent                        FB
      strcpy(old_ap,  ap);


     strcpy(old_essid,essid) ;

     strcat(ap_store,temp) ;

     if (generate)
     fprintf(ff,"essid=%s ap_mac=%s\n",essid ,  ap);

     if (monitor)
     {
     monitor_mode();
     }
     // reset the ESSID and hope the driver takes it
     reset_essid( sock, wdev ) ;  /* reset the ESSID */
      
    sleep(1);
    } 
   
  

    /* sleep long enough to scan */
  
  close(sock);
}


/**************************************************
 interface support 
 **************************************************/


usage(){
fprintf(stderr,"pants int_sleeptime device");
		exit(1);
}
/**************************************************
 Main               
 **************************************************/
main(int argc, char *argv[])
 {
 monitor = 0;
 generate = 0;
 DEBUG = 0;

  // set debug flag
  //
 if ( getenv("DEBUG")  )
      DEBUG = 1;
//   Should use getopts but i hate it
  if (argc != 4 )
     {
     fprintf(stderr,"wrong num %i \n", argc);
     usage();
     }


  strcpy(wdev,argv[2]);

  sleeptime=atoi(argv[1]);
//
//Generate a file full of local Access Points
//
  if (strcmp("generate",argv[3]) == 0)
      {
     fprintf(stderr,"generate \n");
     monitor = 0;
     generate = 1;
     if ( (ff=fopen(CONF_FILE,"w")) == NULL )
        {
        perror("file");
        exit(1);
	}

     look();
     fclose(ff);
     exit(1);
      }

    if ( strcmp("monitor",argv[3]) != 0)
       {
       fprintf(stderr,"command mustx be monitor or generate \n");
	usage() ;
       }
	//     It must be "monitor mode"
     loadpattern();
     monitor = 1;
     generate = 0;
     while(1)
	{
       sleep(sleeptime);
       look();
       system("Controlexit");
//     Control exit - call to routine that checks for probe frames
       
       }
  }
